"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeepLTranslate = void 0;
const deepl = __importStar(require("deepl-node"));
const util_1 = require("./util");
const supportedLanguages = [
    "AR",
    "BG",
    "CS",
    "DA",
    "DE",
    "EL",
    "EN",
    "EN-GB",
    "EN-US",
    "EN",
    "ES",
    "ET",
    "FI",
    "FR",
    "HU",
    "ID",
    "IT",
    "JA",
    "LT",
    "LV",
    "NB",
    "NL",
    "PL",
    "PT",
    "PT-PT",
    "PT-BR",
    "PT",
    "RO",
    "RU",
    "SK",
    "SL",
    "SV",
    "TR",
    "UK",
    "ZH",
];
class DeepLTranslate {
    constructor(subscriptionKey, type) {
        this.subscriptionKey = subscriptionKey;
        this.type = type;
        this.endpoint = "https://api.deepl.com";
        if (this.type === "free") {
            this.endpoint = "https://api-free.deepl.com";
        }
    }
    isValidLocale(targetLocale) {
        return supportedLanguages.includes(targetLocale.toUpperCase());
    }
    translateText(text, sourceLocale, targetLocale) {
        return __awaiter(this, void 0, void 0, function* () {
            let args;
            ({ args, text } = util_1.Util.replaceContextVariables(text));
            let result = "";
            const translator = new deepl.Translator(this.subscriptionKey, {
                serverUrl: this.endpoint,
                minTimeout: 10000,
                maxRetries: 5,
            });
            const translation = yield translator.translateText(text, sourceLocale, targetLocale);
            result = translation.text;
            result = util_1.Util.replaceArgumentsWithNumbers(args, result);
            return result;
        });
    }
}
exports.DeepLTranslate = DeepLTranslate;
// https://www.deepl.com/docs-api/translating-text/example/
