import type { TranslationFile } from "./translate.interface";
export interface IFiles {
    sourceLocale: string;
    targetLocales: Array<string>;
    loadJsonFromLocale(locale: string): Promise<TranslationFile>;
    saveJsonToLocale(locale: string, file: TranslationFile): void;
}
export declare const readFileAsync: (filename: string) => Promise<string>;
export declare const loadJsonFromLocale: (fileName: string) => Promise<TranslationFile>;
export declare const saveJsonToLocale: (filename: string, file: TranslationFile) => void;
export declare class Files implements IFiles {
    folderPath: string;
    sourceLocale: string;
    targetLocales: Array<string>;
    constructor(filePath: string);
    private getLocaleFromFilename;
    private getTargetLocales;
    loadJsonFromLocale(locale: string): Promise<TranslationFile>;
    saveJsonToLocale(locale: string, file: TranslationFile): void;
}
