"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Files = exports.saveJsonToLocale = exports.loadJsonFromLocale = exports.readFileAsync = void 0;
const fs = __importStar(require("node:fs"));
const path = __importStar(require("node:path"));
const readFileAsync = (filename) => new Promise((resolve, reject) => {
    const exist = fs.existsSync(filename);
    if (!exist)
        fs.writeFileSync(filename, "");
    fs.readFile(filename, (error, data) => {
        error ? reject(error) : resolve(data.toString());
    });
});
exports.readFileAsync = readFileAsync;
const loadJsonFromLocale = (fileName) => __awaiter(void 0, void 0, void 0, function* () {
    let data = yield (0, exports.readFileAsync)(fileName);
    // handle empty files
    if (!data) {
        data = "{}";
    }
    return JSON.parse(data);
});
exports.loadJsonFromLocale = loadJsonFromLocale;
const saveJsonToLocale = (filename, file) => {
    const data = JSON.stringify(file, null, "  ");
    fs.writeFileSync(filename, data, "utf8");
};
exports.saveJsonToLocale = saveJsonToLocale;
class Files {
    constructor(filePath) {
        this.folderPath = path.dirname(filePath);
        const fileName = path.basename(filePath);
        this.sourceLocale = this.getLocaleFromFilename(fileName);
        this.targetLocales = this.getTargetLocales();
    }
    getLocaleFromFilename(fileName) {
        return fileName.replace(".json", "");
    }
    getTargetLocales() {
        const locales = [];
        const files = fs.readdirSync(this.folderPath);
        for (const file of files) {
            const locale = this.getLocaleFromFilename(file);
            if (locale !== this.sourceLocale) {
                locales.push(locale);
            }
        }
        return locales;
    }
    loadJsonFromLocale(locale) {
        const filename = `${this.folderPath}/${locale}.json`;
        return (0, exports.loadJsonFromLocale)(filename);
    }
    saveJsonToLocale(locale, file) {
        const filename = `${this.folderPath}/${locale}.json`;
        (0, exports.saveJsonToLocale)(filename, file);
    }
}
exports.Files = Files;
